var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
import { getClassName } from '@react-devui/utils';
import { usePrefixConfig, useComponentConfig } from '../../hooks';
import { registerComponentMate } from '../../utils';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DBreadcrumb' });
export function DBreadcrumb(props) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { dList, dSeparator, onItemClick } = _a, restProps = __rest(_a, ["dList", "dSeparator", "onItemClick"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    return (_jsx("nav", Object.assign({}, restProps, { className: getClassName(restProps.className, `${dPrefix}breadcrumb`) }, { children: _jsx("ol", Object.assign({ className: `${dPrefix}breadcrumb__list` }, { children: dList.map((item, index) => {
                var _a, _b;
                return (_jsxs(React.Fragment, { children: [_jsx("li", Object.assign({ className: getClassName(`${dPrefix}breadcrumb__item`, {
                                [`${dPrefix}breadcrumb__item--link`]: item.link,
                                [`${dPrefix}breadcrumb__item--last`]: index === dList.length - 1,
                            }), onClick: () => {
                                onItemClick === null || onItemClick === void 0 ? void 0 : onItemClick(item.id, item);
                            } }, { children: item.title })), index !== dList.length - 1 && (_jsx("li", Object.assign({ className: `${dPrefix}breadcrumb__separator`, "aria-hidden": true }, { children: (_b = (_a = item.separator) !== null && _a !== void 0 ? _a : dSeparator) !== null && _b !== void 0 ? _b : '/' })))] }, item.id));
            }) })) })));
}
//# sourceMappingURL=Breadcrumb.js.map