var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { checkNodeExist, getClassName } from '@react-devui/utils';
import { usePrefixConfig, useComponentConfig, useGeneralContext, useDValue } from '../../hooks';
import { registerComponentMate } from '../../utils';
import { DBaseInput } from '../_base-input';
import { useFormControl } from '../form';
import { DCheckboxGroup } from './CheckboxGroup';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DCheckbox' });
export const DCheckbox = (props) => {
    const _a = useComponentConfig(COMPONENT_NAME, props), { children, dFormControl, dModel, dDisabled = false, dIndeterminate = false, dInputProps, dInputRef, onModelChange } = _a, restProps = __rest(_a, ["children", "dFormControl", "dModel", "dDisabled", "dIndeterminate", "dInputProps", "dInputRef", "onModelChange"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    const { gDisabled } = useGeneralContext();
    //#endregion
    const formControlInject = useFormControl(dFormControl);
    const [checked, changeChecked] = useDValue(false, dIndeterminate ? false : dModel, onModelChange, undefined, formControlInject);
    const disabled = dDisabled || gDisabled || (dFormControl === null || dFormControl === void 0 ? void 0 : dFormControl.control.disabled);
    return (_jsxs("label", Object.assign({}, restProps, { className: getClassName(restProps.className, `${dPrefix}checkbox`, {
            'is-indeterminate': dIndeterminate,
            'is-checked': checked,
            'is-disabled': disabled,
        }) }, { children: [_jsxs("div", Object.assign({ className: `${dPrefix}checkbox__state-container` }, { children: [_jsx(DBaseInput, Object.assign({}, dInputProps, { ref: dInputRef, className: getClassName(dInputProps === null || dInputProps === void 0 ? void 0 : dInputProps.className, `${dPrefix}checkbox__input`), type: "checkbox", disabled: disabled, "aria-checked": dIndeterminate ? 'mixed' : checked, onChange: (e) => {
                            var _a;
                            (_a = dInputProps === null || dInputProps === void 0 ? void 0 : dInputProps.onChange) === null || _a === void 0 ? void 0 : _a.call(dInputProps, e);
                            changeChecked(!checked);
                        }, dFormControl: dFormControl })), dIndeterminate ? (_jsx("div", { className: `${dPrefix}checkbox__indeterminate` })) : (checked && _jsx("div", { className: `${dPrefix}checkbox__tick` }))] })), checkNodeExist(children) && _jsx("div", Object.assign({ className: `${dPrefix}checkbox__label` }, { children: children }))] })));
};
DCheckbox.Group = DCheckboxGroup;
//# sourceMappingURL=Checkbox.js.map