var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { getClassName } from '@react-devui/utils';
import { usePrefixConfig, useComponentConfig, useGeneralContext } from '../../hooks';
import { convertHex, registerComponentMate } from '../../utils';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DTag' });
export function DTag(props) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { children, dType = 'primary', dTheme, dColor, dSize } = _a, restProps = __rest(_a, ["children", "dType", "dTheme", "dColor", "dSize"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    const { gSize } = useGeneralContext();
    //#endregion
    const size = dSize !== null && dSize !== void 0 ? dSize : gSize;
    return (_jsx("div", Object.assign({}, restProps, { className: getClassName(restProps.className, `${dPrefix}tag`, `${dPrefix}tag--${dType}`, {
            [`${dPrefix}tag--${size}`]: size,
            [`t-${dTheme}`]: dTheme,
        }), style: Object.assign(Object.assign({}, restProps.style), (dColor
            ? {
                [`--${dPrefix}tag-color`]: dColor,
                [`--${dPrefix}tag-background-color`]: convertHex(dColor, 0.1),
            }
            : {})) }, { children: children })));
}
//# sourceMappingURL=Tag.js.map