import type { DFormControl } from './FormItem';
import type { FormGroup } from './form-control';
export interface DFormInstance {
    form: FormGroup;
    initForm: () => void;
    updateForm: () => void;
}
export declare function useForm(initData: () => FormGroup): DFormInstance;
export declare type DFormControlInject = [any, (val: any) => void] | undefined;
export declare function useFormControl(formControl?: DFormControl): DFormControlInject;
