import React from 'react';
export interface DPanelRef {
    updateView: (time: Date) => void;
}
export interface DPanelProps {
    dTime: Date | null;
    dCols: ('hour' | 'minute' | 'second')[];
    d12Hour?: boolean;
    dConfigTime?: (unit: 'hour' | 'minute' | 'second', value: number) => {
        disabled?: boolean;
        hidden?: boolean;
    };
    onTimeChange?: (time: Date) => void;
}
export interface DPanelPropsWithPrivate extends DPanelProps {
    __header?: boolean;
}
export declare const DPanel: React.ForwardRefExoticComponent<DPanelProps & React.RefAttributes<DPanelRef>>;
